"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const Button_1 = __importDefault(require("../Button"));
const style_1 = __importDefault(require("./style"));
let alertView = undefined;
;
const AlertView = ({ height = 250, message, title, button = '确定', onSubmit, }) => {
    const duration = 500;
    const fadeAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    const fadeScale = (0, react_1.useRef)(new react_native_1.Animated.Value(1)).current;
    const fadeOut = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
        react_native_1.Animated.timing(fadeScale, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
    };
    const fadeIn = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 1,
            duration,
            useNativeDriver: true
        }).start();
    };
    fadeIn();
    const _onPress = () => {
        fadeOut();
        setTimeout(() => {
            alertView === null || alertView === void 0 ? void 0 : alertView.destroy();
            onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit();
        }, duration);
    };
    return (<react_native_1.Animated.View style={[
            style_1.default.animate,
            { opacity: fadeAnim }
        ]}>
            <react_native_1.View style={style_1.default.container}>
                <react_native_1.Animated.View style={[
            style_1.default.box,
            { transform: [{ scale: fadeScale }], height }
        ]}>
                    {title && (<react_native_1.View style={style_1.default.title}>
                                <react_native_1.Text style={style_1.default.titleText}>{title}</react_native_1.Text>
                            </react_native_1.View>)}
                    <react_native_1.ScrollView style={style_1.default.content}>
                        <react_native_1.Text style={[
            style_1.default.contentText,
        ]}>
                            {message}
                        </react_native_1.Text>
                    </react_native_1.ScrollView>
                    <react_native_1.View style={{ height: 20 }}/>
                    <Button_1.default styleContainer={style_1.default.button} styleText={style_1.default.buttonText} text={button} onPress={_onPress}/>
                </react_native_1.Animated.View>
            </react_native_1.View>
        </react_native_1.Animated.View>);
};
const Alert = (_a) => {
    var props = __rest(_a, []);
    alertView === null || alertView === void 0 ? void 0 : alertView.destroy();
    alertView = new react_native_root_siblings_1.default(<AlertView {...props}/>);
};
exports.default = Alert;
