"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Colors_1 = __importDefault(require("../Colors"));
;
const Button = ({ styleContainer, styleText, text = '', children, onPress, onLongPress, }) => {
    const _onPress = () => {
        onPress === null || onPress === void 0 ? void 0 : onPress();
    };
    const _onLongPress = () => {
        onLongPress === null || onLongPress === void 0 ? void 0 : onLongPress();
    };
    const renderView = () => {
        if (children) {
            if (styleContainer) {
                return (<react_native_1.View style={styleContainer}>
                        {children}
                    </react_native_1.View>);
            }
            else {
                return <>{children}</>;
            }
        }
        else {
            return (<react_native_1.View style={styleContainer}>
                    <react_native_1.Text style={styleText}>
                        {text}
                    </react_native_1.Text>
                </react_native_1.View>);
        }
    };
    return (<react_native_1.TouchableNativeFeedback background={Colors_1.default.TouchColor} onPress={_onPress} onLongPress={_onLongPress}>
            {renderView()}
        </react_native_1.TouchableNativeFeedback>);
};
exports.default = Button;
