"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const bottom_tabs_1 = require("@react-navigation/bottom-tabs");
const native_stack_1 = require("@react-navigation/native-stack");
const NavigatorBar_1 = __importDefault(require("../NavigatorBar"));
const react_redux_1 = require("react-redux");
const react_native_1 = require("react-native");
const Tab = (0, bottom_tabs_1.createBottomTabNavigator)();
const Stack = (0, native_stack_1.createNativeStackNavigator)();
;
const TabsNavigation = ({ tabs = [], }) => {
    const { styleSafe } = (0, react_redux_1.useSelector)((state) => state.common);
    return (<react_native_1.SafeAreaView style={Object.assign({}, styleSafe)}>
            <Tab.Navigator screenOptions={{
            headerShown: false,
            tabBarHideOnKeyboard: true,
        }} tabBar={(props) => <NavigatorBar_1.default {...props}/>}>
                {tabs.map((v, k) => {
            if (!v.tab)
                return null;
            return (<Tab.Screen key={`itabs_${k}`} name={v.name} component={v.component} options={Object.assign({}, v)}/>);
        })}
            </Tab.Navigator>
        </react_native_1.SafeAreaView>);
};
;
const Route = ({ routes = [], }) => {
    const { start } = (0, react_redux_1.useSelector)((state) => state.common);
    return (<Stack.Navigator initialRouteName={start || 'Index'} screenOptions={{
            headerShown: false
        }}>
            <Stack.Screen name='Index'>
                {() => <TabsNavigation tabs={routes}/>}
            </Stack.Screen>
            
            {routes === null || routes === void 0 ? void 0 : routes.map((v, k) => {
            if (v.tab)
                return null;
            return (<Stack.Screen key={`menu_${k}`} name={v.name} component={v.component}/>);
        })}
        </Stack.Navigator>);
};
exports.default = Route;
