"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const picker_1 = require("@react-native-picker/picker");
const Drawer_1 = __importDefault(require("../Drawer"));
const style_1 = __importDefault(require("./style"));
const Button_1 = __importDefault(require("../Button"));
let selectView = undefined;
const SelectView = ({ value = '', ratio = 40, title, options, onSubmit, }) => {
    const refDrawer = (0, react_1.useRef)();
    const refPicker = (0, react_1.useRef)();
    const [current, setCurrent] = (0, react_1.useState)('');
    (0, react_1.useLayoutEffect)(() => {
        var _a;
        (_a = refDrawer === null || refDrawer === void 0 ? void 0 : refDrawer.current) === null || _a === void 0 ? void 0 : _a.show();
        let cur = value;
        if (!value) {
            cur = options === null || options === void 0 ? void 0 : options[0].value;
        }
        setCurrent(cur);
    }, []);
    const _onClose = () => {
        selectView === null || selectView === void 0 ? void 0 : selectView.destroy();
        selectView = undefined;
    };
    const _onPicker = (item) => {
        setCurrent(item);
    };
    const _onSubmit = () => {
        var _a;
        (_a = refDrawer === null || refDrawer === void 0 ? void 0 : refDrawer.current) === null || _a === void 0 ? void 0 : _a.hide();
        onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit(current);
    };
    const _onCancel = () => {
        var _a;
        (_a = refDrawer === null || refDrawer === void 0 ? void 0 : refDrawer.current) === null || _a === void 0 ? void 0 : _a.hide();
    };
    const Header = () => {
        return (<react_native_1.View style={style_1.default.header}>
                <Button_1.default styleContainer={style_1.default.headerButton} styleText={style_1.default.leftText} text='取消' onPress={() => {
                _onCancel();
            }}/>

                <react_native_1.View style={style_1.default.title}>
                    <react_native_1.Text>{title}</react_native_1.Text>
                </react_native_1.View>

                <Button_1.default styleContainer={style_1.default.headerButton} styleText={style_1.default.rightText} text='确定' onPress={() => {
                _onSubmit();
            }}/>
            </react_native_1.View>);
    };
    return (<Drawer_1.default ratio={ratio} style={style_1.default.container} cRef={refDrawer} scrollView={false} onClose={_onClose} header={<Header />}>
            <picker_1.Picker ref={refPicker} selectedValue={current} onValueChange={(item) => _onPicker(item)}>
                {(options === null || options === void 0 ? void 0 : options.length) ? options.map((v, k) => (<picker_1.Picker.Item label={v.label} value={v.value} key={`opt_${k}`}/>)) : null}
            </picker_1.Picker>
        </Drawer_1.default>);
};
const Select = (_a) => {
    var props = __rest(_a, []);
    selectView === null || selectView === void 0 ? void 0 : selectView.destroy();
    selectView = new react_native_root_siblings_1.default(<SelectView {...props}/>);
};
exports.default = Select;
