"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_swiper_1 = __importDefault(require("react-native-swiper"));
const getSize_1 = __importDefault(require("../Fn/getSize"));
const reducer_1 = __importDefault(require("../Fn/reducer"));
const static_1 = __importDefault(require("../Fn/static"));
const style_1 = __importDefault(require("./style"));
const Slide = ({ images }) => {
    const initState = {
        width: 0,
        height: 0,
        show: false,
    };
    const [state, dispatch] = (0, reducer_1.default)(Object.assign({}, initState));
    (0, react_1.useEffect)(() => {
        if (!(images === null || images === void 0 ? void 0 : images.length))
            return;
        getSize();
    }, [images]);
    const getSize = () => __awaiter(void 0, void 0, void 0, function* () {
        const res = yield (0, getSize_1.default)(images[0], static_1.default.spacing * 2);
        dispatch({
            width: res.width,
            height: res.height,
            show: true,
        });
    });
    const renderSlide = (0, react_1.useCallback)(() => {
        if (!(state === null || state === void 0 ? void 0 : state.show) || !state.height)
            return null;
        return (<react_native_swiper_1.default style={{ height: state.height }} showsButtons={false} loop={true} autoplay={true} autoplayTimeout={4} dot={<react_native_1.View style={style_1.default.swipeDot}/>} activeDot={<react_native_1.View style={[style_1.default.swipeDot, style_1.default.swipeDotActive]}/>}>
                {images.map((v, k) => (<react_native_1.View key={`sp_${k}`} style={style_1.default.swipeItem}>
                            <react_native_1.Image style={{
                    width: state.width,
                    height: state.height,
                }} source={{ uri: v }} resizeMode='contain'/>
                        </react_native_1.View>))}
            </react_native_swiper_1.default>);
    }, [images, state]);
    return renderSlide();
};
exports.default = Slide;
